#
# disables the check: brp-java-repack-jars
# needed that the following error do not happen:
#  Unhandled exception: java.lang.RuntimeException: Bytecode jar contains
#  unexpected file META-INF/
#     in  (src/stage2/gen/NQP.nqp)
#
%define __jar_repack %{nil}


# disable empty nqp-debug package
%define debug_package %{nil}


%global year 2016
%global month 01 


Name:           rakudo-star
Version:        0.0.%{year}.%{month}
Release:        1%{?dist}
Summary:        This is Rakudo Star, a useful, usable Perl 6 production distribution.
License:        Artistic 2.0
Group:          Development/Languages
URL:            http://www.rakudo.org/

Source0:        http://rakudo.org/downloads/star/rakudo-star-%{year}.%{month}.tar.gz
# sources for desktop files are added here
Source1:        ftp://ftp.uni-siegen.de/pub/desk/rakudo.desk.tar.gz

BuildRequires:  perl(ExtUtils::Command)
BuildRequires:  perl(Test::Harness)

BuildRequires:  readline-devel

BuildRequires:  nqp >= 0.0.%{year}.%{month}
Requires:  nqp >= 0.0.%{year}.%{month}


# Build with MoarVM
BuildRequires:  nqp >= 0.0.%{year}.%{month}
Requires:  nqp >= 0.0.%{year}.%{month}
BuildRequires:  moarvm-devel
BuildRequires:  libuv-devel
BuildRequires:  libatomic_ops-devel
BuildRequires:  libtommath-devel
BuildRequires:  sha-devel

# disable the building of the JVM subpackage dependent of the architecture
%define build_jvm_exec 0

# Build with JVM
%if %{build_jvm_exec}
BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  java-devel

Requires:       java

BuildRequires:  nqp-jvm >= 0.0.%{year}.%{month}
Requires:  nqp-jvm >= 0.0.%{year}.%{month}
%endif


# Needed for desktop-file-install usage
BuildRequires:  desktop-file-utils


# Replacing existing "rakudo" package
Obsoletes:      rakudo <= 0.0.2010.08_2.7.0-2
Provides:       rakudo = %{version}-%{release}


# filter out the perl5 modules requires for perl6 modules
%filter_from_requires /perl(/d; /perl6/d
%filter_setup


%description
Rakudo Perl 6, or just Rakudo, is a Perl 6 compiler targeting the MoarVM and
the JVM. Rakudo Star fully supports MoarVM; not all modules work on the JVM
at present. More information about Perl 6 is available from:
http://perl6.org
Rakudo Star is a collection of things around Rakudo. It installs Perl 6 modules.


%prep
%setup -q -n %{name}-%{year}.%{month}


%build
%{__perl} Configure.pl --backends=moar --prefix=/usr

# add flags like '-g' to CFLAGS
#%{__sed} -i -e "/^CFLAGS/ s/$/ $RPM_OPT_FLAGS/" Makefile
#%{__sed} -i -e "/^CFLAGS/ s/$/  -O2 -g -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches  -m64 -mtune=generic/" Makefile

%{__make}  # %{?_smp_mflags}


%install
# Grep reports BUILDROOT inside our object files; disable that test.
QA_SKIP_BUILD_ROOT=1
export QA_SKIP_BUILD_ROOT


%{__rm} -rf $RPM_BUILD_ROOT


# Rakudo installation
%{__sed} -i -e 's&$(DESTDIR)$(DOCDIR)/rakudo&$(DESTDIR)$(DOCDIR)/rakudo-star/rakudo&' rakudo/Makefile

%{__make} rakudo-install DESTDIR=$RPM_BUILD_ROOT
#%{__make} modules-install DESTDIR=$RPM_BUILD_ROOT
#%{__make} install DESTDIR=$RPM_BUILD_ROOT

# Generating man-pages
%{__perl} -MExtUtils::Command -e mkpath $RPM_BUILD_ROOT%{_mandir}/man1
pod2man --section=1 --name=perl6 rakudo/docs/running.pod | %{__gzip} -c > $RPM_BUILD_ROOT%{_mandir}/man1/perl6.1.gz
pod2man --section=1 --name=perl6-m rakudo/docs/running.pod | %{__gzip} -c > $RPM_BUILD_ROOT%{_mandir}/man1/perl6-m.1.gz


# install desktop files for doc-URL and Perl6-presentation-PDF-document
%define DESK_TARGET $RPM_BUILD_ROOT%{_datadir}/applications/
%{__mkdir} -p %{DESK_TARGET}
%{__tar} xzf %{SOURCE1} --directory=%{DESK_TARGET}

desktop-file-install --delete-original --add-category="Documentation"  \
    --dir=%{DESK_TARGET} %{DESK_TARGET}perl6_doc_link.desktop
desktop-file-install --delete-original --add-category="Documentation"  \
    --dir=%{DESK_TARGET} %{DESK_TARGET}rakudo_guide_pdf.desktop



%check
%{__make} rakudo-test


%clean
%{__rm} -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
#
%doc LICENSE README docs/CREDITS docs/cheatsheet.txt docs/2015-spw-perl6-course.pdf
%{_bindir}/perl6
%{_bindir}/perl6-m
%{_bindir}/perl6-debug-m
%{_bindir}/perl6-gdb-m
%{_bindir}/perl6-valgrind-m

%{_datadir}/nqp/lib/Perl6
%{_datadir}/perl6/*
%{_datadir}/perl6/runtime/*
%{_mandir}/man1/perl6.1.gz
%{_mandir}/man1/perl6-m.1.gz


# desktop files
%{_datadir}/applications/perl6_doc_link.desktop
%{_datadir}/applications/rakudo_guide_pdf.desktop

# JVM files
%if %{build_jvm_exec}
%{_bindir}/perl6-j
%{_bindir}/perl6-debug-j
%{_bindir}/perl6-eval-server
%{_bindir}/perl6-jdb-server
%{_datadir}/perl6/lib
%{_datadir}/perl6/lib/Perl6
%{_datadir}/perl6/runtime/dynext
%{_datadir}/perl6/runtime/*.moarvm
%endif


%changelog
* Tue Dec 01 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.11
- updated to 2015.11

* Wed Jun 24 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.06.2
- add module copy

* Wed Jun 24 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.06.1
- updated to 2015.06

* Mon Jun 01 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.05.1
- updated to 2015.05

* Mon May 04 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.04.4
- add man-pages generating
- module files goes to _datadir/perl6/lib
- force executable permission on shared object so that get stripped

* Sat May 02 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.04.3
- disable jar repack (define __jar_repack nil)

* Fri May 01 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.04.2
- disable empty debug package

* Tue Apr 28 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2015.04.1
- remove parrot as backend
- making MoarVM to the main backend
- updated to 2015.04

* Tue Jan 27 2015 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2014.12.1_6.10.0-1
- updated to 2014.12.1

* Sat Aug 16 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2014.04_6.1.0-1
- updated to 2014.04
- prepare for JVM and MoarVM

* Thu Apr 03 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2014.03_6.1.0-1
- updated to 2014.03
- add desktop file source with no versions

* Wed Feb 19 2014 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2014.01_5.9.0-1
- updated to 2014.01
- add prefix option to Configure.pl
- remove f20 doc file fix

* Sat Oct 05 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2013.09_5.5.0-1
- updated to 2013.09
- remove perl6_group.so

* Tue Aug 06 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2013.05_5.2.0-4
- fix f20 doc file issue, use _pkgdocdir marco and makes it unversioned

* Sat Jun 01 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2013.05_5.2.0-1
- updated to 2013.05

* Thu Jan 31 2013 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2013.01_5.0.0-1 
- updated to 2013.01
- change source to new download URL
- rebuild with new ICU
- add nqp-requires

* Wed Sep 05 2012 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2012.08_4.7.0-2
- BuildRoot tag removed
- first build on top of NQP
- extended requires filter
- updated to 2012.08

* Fri Aug 05 2011 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2011.07_3.6.0-1
- updated to 2011.07

* Thu Apr 28 2011 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2011.04_3.3.0-1
- updated to 2011.04

* Sat Jan 29 2011 Gerd Pokorra <gp@zimt.uni-siegen.de> - 0.0.2011.01_3.0.0-1
- updated to 2011.01

* Wed Sep 08 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-6
- changed provides/obseletes for "rakudo" package

* Wed Sep 08 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-5
- add provides/obseletes for replacing the existing "rakudo" package

* Wed Sep 08 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-4
- let rakudo read the 'optimize' value of the parrot configuration this add flags like '-g' to CFLAGS

* Fri Sep 03 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-3
- consistent use of $RPM_BUILD_ROOT

* Thu Sep 02 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-2
- changed permission of source files
- added tests for modules
- changed the place of the installed perl-script "ufo" 

* Tue Aug 31 2010 Gerd Pokorra <gp@zimt.uni-siegen.de> 0.0.2010.08_2.7.0-1
- filter out the perl5 modules requires for perl6 modules
- desktop files added
- initial .spec file
